<?php
/***********************************************************************
 * Module:  ConfigGenerator.php
 * Author:  vallance
 * Purpose: Defines the Class ConfigGenerator
 ***********************************************************************/

class ConfigGenerator {
	private $configWay;
	 
	public function __construct() {
		$this->configWay = new ConfigWay();
	}
	
	/**
	 * Display the config file content assist creator system.
	 * 
	 * @return array|NULL
	 */
	public function generate() {
		
		echo "Welcome to the configuration file generator. The following steps will guide you to create you'r own config.\n\n";
		
		$varArray = array();
		
		while(true){

			$this->configWay->rewind();
			for (; $this->configWay->valid() ; $this->configWay->next() ) {
				echo $this->configWay->current()['description']."\n";

				if($this->configWay->current()['multiply']){
					$varArray[$this->configWay->current()['var']] = array();
				}
				
				while(true){
						
					echo $this->configWay->current()['title'];
					
					if($this->configWay->current()['default'] != ""){
						echo " [".(new Colors())->getColoredString($this->configWay->current()['default'], 'green')."]";
					}
					
					echo " : ";

					$var = util::read_stdin();
					
					if($this->configWay->current()['multiply']){
						if(count($varArray[$this->configWay->current()['var']]) > 0 && $var == $this->configWay->current()['exit']){
							break 1;
						}else if($var == $this->configWay->current()['exit']){
							echo (new Colors())->getColoredString("This field cannot be empty\n", 'red');
						}else{
							$varArray[$this->configWay->current()['var']][] = $var;
						}
					}else{

						if($var == $this->configWay->current()['exit'] && $this->configWay->current()['default'] == ""){
							echo (new Colors())->getColoredString("This field cannot be empty\n", 'red');
						}else if($var == $this->configWay->current()['exit']){
							$varArray[$this->configWay->current()['var']] = $this->configWay->current()['default'];
							break 1;
						}else{
							$varArray[$this->configWay->current()['var']] = $var;
							break 1;
						}
					}
				}
				echo "\n";
			}

			echo "\n\n";
			$this->configWay->rewind();
			for (; $this->configWay->valid() ; $this->configWay->next() ) {
				echo "\n".$this->configWay->current()['title'].":";
				
				if($this->configWay->current()['multiply']){
					foreach ($varArray[$this->configWay->current()['var']] as $value) {
						echo "\n\t".$value."";
					}
				}else{
					echo "\t".$varArray[$this->configWay->current()['var']];
				}
			}
			
			while(true){
				echo "\n\nDid you accept this configuration ? (Y-N) : ";
				
				$choice = util::read_stdin();
				if(strtoupper($choice) == 'Y'){
					return $varArray;
				}else if(strtoupper($choice) == 'N'){
					for ($i = 0; $i < 20; $i++) {
						echo "\n";
					}
					break 1;
				}
			}
		
		}
		return null;
	}

}