<?php
/***********************************************************************
 * Module:  ConfigWay.php
 * Author:  vallance
 * Purpose: Defines the Class ConfigWay
 ***********************************************************************/

class ConfigWay implements \Iterator {
   private $way = array();
   private $position;
   
	/**
	 * Default constructor. Initialise the way.
	 */
	public function __construct() {
		$this->position = 0;
		
		$this->way[] = array(
						'description'=>"The ajs directory will contain all of the ajs file. This file contain the compilation protocol. You can specify multiple ajs directory. Press ENTER to pass.",
						'multiply'=>true,
						'exit'=>"",
						'default'=>"",
						'title'=>"ajs directory",
						'var'=>'ajs'
		);

		$this->way[] = array(
						'description'=>"The js directory will contain all of the javaScript source file. You can specify multiple js directory. Press ENTER to pass.",
						'multiply'=>true,
						'exit'=>"",
						'default'=>"",
						'title'=>"js directory",
						'var'=>'js'
		);

		$this->way[] = array(
						'description'=>"The output directory will contain the compilation result file.",
						'multiply'=>false,
						'exit'=>"",
						'default'=>"./output/",
						'title'=>"output directory",
						'var'=>'output'
		);

		$this->way[] = array(
						'description'=>"The line break is the maximum character length of result line. Only work with minify option. 40 characters minimum.",
						'multiply'=>false,
						'exit'=>"",
						'default'=>"7000",
						'title'=>"line break",
						'var'=>'linebreak'
		);

		$this->way[] = array(
						'description'=>"The verbose option will display more information on compilation process.",
						'multiply'=>false,
						'exit'=>"",
						'default'=>"false",
						'title'=>"verbose",
						'var'=>'verb'
		);

		$this->way[] = array(
						'description'=>"The minify option will minify the compiled file.",
						'multiply'=>false,
						'exit'=>"",
						'default'=>"true",
						'title'=>"minify",
						'var'=>'min'
		);
	}

	/**
	 * Checks if current position is valid
	 * 
	 * @see Iterator::valid()
	 */
	public function valid() {
		if(isset($this->way[$this->position])){
			return true;
		}else{
			return false;
		}
	}

	/**
	 * Move forward to next element
	 * 
	 * @see Iterator::next()
	 */
	public function next() {
		++$this->position;
	}

	/**
	 * return the current element.
	 *  
	 * @see Iterator::current()
	 */
	public function current() {
		return $this->way[$this->position];
	}

	/**
	 * Rewind the Iterator to the first element
	 * 
	 * @see Iterator::rewind()
	 */
	public function rewind() {
		$this->position = 0;
	}

	/**
	 * Return the key of the current element
	 * 
	 * @see Iterator::key()
	 */
	public function key() {
		return $this->position;
	}

}