<?php
/***********************************************************************
 * Module:  FileManager.php
 * Author:  vallance
 * Purpose: Defines the Interface FileManager
 ***********************************************************************/

class FileManager {

	/**
	 * return file text content.
	 * 
	 * @param string $fileName
	 * @param array $jsPathArray
	 * @return string|NULL
	 */
	public function getInputFile($fileName, $jsPathArray) {
		
		foreach ($jsPathArray as $jsDir) {
			if(is_file($jsDir.$fileName)){
				return file_get_contents($jsDir.$fileName);
			}
		}
		return null;
		
	}
	
	/**
	 * Write file text content.
	 * 
	 * @param string $filename
	 * @param string $output
	 * @param string $content
	 */
	public function setOutputFile($filename, $output, $content) {
		
		if(is_dir($output)){
			if(!file_put_contents($output.$filename, $content)){
				echo (new Colors())->getColoredString("error : ", "red")."file ".$output.$filename." can't be write\n";
			}
		}else{
			echo (new Colors())->getColoredString("error : ", "red")."output directory ".$output." does not exist\n";
		}
		
	}
	
}