<?php
/***********************************************************************
 * Module:  XMLParser.php
 * Author:  vallance
 * Purpose: Defines the Class XMLParser
 ***********************************************************************/

class XMLParser {
	
	const CONFIG_FILE_PATH = "fusionConfig.conf";
	
	private $config;
	 
	/** @param config */
	public function __construct(ConfigObject $config) {
	
		$this->config = $config;
		
	}
	 
	/**
	 * Write the config xml file of fusion.
	 * 
	 * @return NULL
	 */
	public function create() {
	
		$xml = new \SimpleXMLElement ( '<xml/>' );
		
		$config = $xml->addChild ( 'config' );
		$ajs = $config->addChild ( 'ajs' );
		foreach ($this->config->getAjsDirectory() as $dir) {
			$ajs->addChild('directory', $dir);
		}
		
		$js = $config->addChild ( 'js' );
		foreach ($this->config->getJsDirectory() as $dir) {
			$js->addChild('directory', $dir);
		}
		
		$config->addChild ( 'output', $this->config->getOutput () );
		$config->addChild ( 'lineBreak', $this->config->getLineBreak () );
		$config->addChild ( 'verbose', $this->config->getVerbose () );
		$config->addChild ( 'minify', $this->config->getMinify () );

		echo "\n\n-----\n".(new Colors())->getColoredString("Creating file fusionConfig.conf", 'light_red');
		file_put_contents ( self::CONFIG_FILE_PATH, $xml->asXML () );
		echo "\n".(new Colors())->getColoredString("DONE", 'green')."\n-----\n";
		
		return null;
	}

}