<?php
/***********************************************************************
 * Module:  AboutObject.php
 * Author:  Administrateur
 * Purpose: Defines the Class AboutObject
 ***********************************************************************/


class AboutObject implements FlowStackInterface {
	private $argArray;
	 
	const VERSION = "4.0.0";
	 
	public function __construct() {
	}
	 
	/**
	 * Display the curent application version.
	 */
	public function display() {
		
		$color = new Colors();
		
		echo "\nCurrent application version : ";
		echo $color->getColoredString($this->getVERSION(), 'green');
		echo "\n\n";
		
		unset($color);
		
	}
	 
	/**
	 * Return the current application version.
	 * 
	 * @return string
	 */
	public static function getVERSION() {
		return self::VERSION;
	}

	/**
	 * Control if the call array arguments referer to the class usage.
	 * This class can be call by -V or --VERSION, with insensitive case.
	 *  
	 * @see FlowStackInterface::control()
	 */
	public function control($argArray) {
		if(isset($argArray[1]) && ( strtoupper($argArray[1]) == '-V' || strtoupper($argArray[1]) == '--VERSION' )){
			return true;
		}else{
			return false;
		}
	}

	/**
	 * Return the method name to call if the control method return true.
	 * 
	 * @see FlowStackInterface::getControlMethod()
	 */
	public function getControlMethod() {
		return "display";
	}

}