<?php
/***********************************************************************
 * Module:  Updater.php
 * Author:  vallance
 * Purpose: Defines the Class Updater
 ***********************************************************************/

class Updater implements \FlowStackInterface {

	private $color;
	
	public function __construct(){
		
		$this->color = new Colors();
		
	}
	
	/**
	 * Execute update of all ajs files.
	 */
	public function update(){
		
		$parser = new AJSParser();
		$finder = new AJSFinder();
		
		$finder->execute($parser);
		
	}

	/**
	 * Control if the call array arguments referer to the class usage.
	 * This class can be call by 'update', with insensitive case.
	 *
	 * @see FlowStackInterface::control()
	 */
	public function control( $argArray ) {
		
		if(isset($argArray[1]) && strtoupper($argArray[1]) == "UPDATE"){
			return true;
		}else{
			return false;
		}
	}

	/**
	 * Return the method name to call if the control method return true.
	 *
	 * @see FlowStackInterface::getControlMethod()
	 */
	public function getControlMethod() {
		return 'update';
	}

}