<?php
/***********************************************************************
 * Module:  Watcher.php
 * Author:  vallance
 * Purpose: Defines the Class Watcher
 ***********************************************************************/

class Watcher implements FlowStackInterface {

	private $arg;
	
	/**
	 * Execute the watching ajs file method.
	 */
	public function run() {
		
		$parser = new AJSParser();
		$finder = new AJSFinder();
		
		$sleep = 1;
		$indicator = "";
		if(isset($this->arg[2]) && is_numeric($this->arg[2])){
			$sleep = (int)$this->arg[2];
		}elseif(isset($this->arg[2])){
			$indicator = $this->arg[2];
		}
		
		if(isset($this->arg[3]) && !is_numeric($this->arg[3])){
			$indicator = $this->arg[3];
		}elseif(isset($this->arg[3]) && is_numeric($this->arg[3])){
			$sleep = (int)$this->arg[3];
		}
		
		$finder->watching($parser, $sleep, $indicator);
		
	}

	/**
	 * Control if the call array arguments referer to the class usage.
	 * This class can be call by 'watch', with insensitive case.
	 *
	 * @see FlowStackInterface::control()
	 */
	public function control($argArray) {
		
		$this->arg = $argArray;
		
		if(isset($argArray[1]) &&  strtoupper($argArray[1]) == "WATCH"){
		
			$this->argArray = $argArray;
			
			return true;
			
		}else{
			return false;
		}
	}

	/**
	 * Return the method name to call if the control method return true.
	 *
	 * @see FlowStackInterface::getControlMethod()
	 */
	public function getControlMethod() {
		return 'run';
	}

}